/// <reference types="express" />
import { Response } from '@loopback/rest';
import { ObjectNode } from '../models';
import { CurrentContext } from '../services/application.service';
import { ObjectNodeContentService } from './../services/object-node-content.service';
import { ObjectNodeService } from './../services/object-node.service';
export declare class ObjectNodeController {
    objectNodeService: ObjectNodeService;
    objectNodeContentService: ObjectNodeContentService;
    constructor(objectNodeService: ObjectNodeService, objectNodeContentService: ObjectNodeContentService);
    create(objectNode: Omit<ObjectNode, 'id'>, ctx: CurrentContext): Promise<ObjectNode>;
    updateById(id: string, objectNode: ObjectNode, ctx: CurrentContext): Promise<ObjectNode>;
    deleteById(id: string, ctx: CurrentContext): Promise<void>;
    downloadFile(id: string, contentType: string, contentId: string, response: Response, ctx: CurrentContext): Promise<Response>;
}
