import { InvocationContext, InvocationResult, ValueOrPromise } from '@loopback/core';
import { CurrentContext } from '../services/application.service';
import { AccessRightsService } from './../services/access-rights/access-rights.service';
import { AbstractInterceptor } from './abstract.interceptor';
/**
 * This class will be bound to the application as an `Interceptor` during
 * `boot`
 */
export declare class ContextInterceptor extends AbstractInterceptor {
    private accessRightsService;
    ctx: CurrentContext;
    constructor(accessRightsService: AccessRightsService, ctx: CurrentContext);
    /**
     * This method is used by LoopBack context to produce an interceptor function
     * for the binding.
     *
     * @returns An interceptor function
     */
    value(): (invocationCtx: InvocationContext, next: () => any) => Promise<any>;
    /**
     * The logic to intercept an invocation
     * @param invocationCtx - Invocation context
     * @param next - A function to invoke next interceptor or the target method
     */
    intercept(invocationCtx: InvocationContext, next: () => ValueOrPromise<InvocationResult>): Promise<any>;
}
