import { InvocationContext, InvocationResult, ValueOrPromise } from '@loopback/context';
import { EntityName } from './../models/entity-name';
import { AbstractInterceptor } from './abstract.interceptor';
declare type EntityType = {
    id?: string;
    uri?: string;
    entityName?: EntityName;
    [key: string]: any;
};
/**
 * This class will be bound to the application as an `Interceptor` during
 * `boot`
 */
export declare class UriCompleteInterceptor extends AbstractInterceptor {
    static readonly BINDING_KEY: string;
    /**
     * This method is used by LoopBack context to produce an interceptor function
     * for the binding.
     *
     * @returns An interceptor function
     */
    value(): (invocationCtx: InvocationContext, next: () => any) => Promise<any>;
    /**
     * The logic to intercept an invocation
     * @param invocationCtx - Invocation context
     * @param next - A function to invoke next interceptor or the target method
     */
    intercept(invocationCtx: InvocationContext, next: () => ValueOrPromise<InvocationResult>): Promise<ValueOrPromise<InvocationResult>>;
    protected addUri(result: EntityType | EntityType[] | any, baseUri: string, objectUri: string, deep?: number): void;
}
export {};
