"use strict";
var ObjectNode_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.ObjectNode = void 0;
const tslib_1 = require("tslib");
const repository_1 = require("@loopback/repository");
const entity_name_1 = require("./entity-name");
const object_type_model_1 = require("./object-type.model");
const rest_entity_model_1 = require("./rest-entity.model");
let ObjectNode = ObjectNode_1 = class ObjectNode extends rest_entity_model_1.RestEntity {
    constructor(data) {
        super(data);
        this.entityName = entity_name_1.EntityName.objectNode;
    }
};
tslib_1.__decorate([
    repository_1.property({
        type: 'string',
        required: true,
    }),
    tslib_1.__metadata("design:type", String)
], ObjectNode.prototype, "name", void 0);
tslib_1.__decorate([
    repository_1.property({
        type: 'boolean',
        default: false,
    }),
    tslib_1.__metadata("design:type", Boolean)
], ObjectNode.prototype, "owner", void 0);
tslib_1.__decorate([
    repository_1.property({
        type: 'boolean',
        default: false,
    }),
    tslib_1.__metadata("design:type", Boolean)
], ObjectNode.prototype, "acl", void 0);
tslib_1.__decorate([
    repository_1.property({
        type: 'boolean',
        default: false,
    }),
    tslib_1.__metadata("design:type", Boolean)
], ObjectNode.prototype, "tree", void 0);
tslib_1.__decorate([
    repository_1.property({
        type: 'boolean',
        default: false,
    }),
    tslib_1.__metadata("design:type", Boolean)
], ObjectNode.prototype, "namespace", void 0);
tslib_1.__decorate([
    repository_1.property({ type: 'array', default: [], itemType: 'string' }),
    tslib_1.__metadata("design:type", Array)
], ObjectNode.prototype, "aclList", void 0);
tslib_1.__decorate([
    repository_1.belongsTo(() => object_type_model_1.ObjectType),
    tslib_1.__metadata("design:type", String)
], ObjectNode.prototype, "objectTypeId", void 0);
tslib_1.__decorate([
    repository_1.belongsTo(() => ObjectNode_1),
    tslib_1.__metadata("design:type", String)
], ObjectNode.prototype, "parentNodeId", void 0);
tslib_1.__decorate([
    repository_1.belongsTo(() => ObjectNode_1),
    tslib_1.__metadata("design:type", String)
], ObjectNode.prototype, "parentOwnerId", void 0);
tslib_1.__decorate([
    repository_1.belongsTo(() => ObjectNode_1),
    tslib_1.__metadata("design:type", String)
], ObjectNode.prototype, "parentTreeId", void 0);
tslib_1.__decorate([
    repository_1.belongsTo(() => ObjectNode_1),
    tslib_1.__metadata("design:type", String)
], ObjectNode.prototype, "parentNamespaceId", void 0);
tslib_1.__decorate([
    repository_1.belongsTo(() => ObjectNode_1),
    tslib_1.__metadata("design:type", String)
], ObjectNode.prototype, "parentACLId", void 0);
ObjectNode = ObjectNode_1 = tslib_1.__decorate([
    repository_1.model({ settings: { strict: false } }),
    tslib_1.__metadata("design:paramtypes", [Object])
], ObjectNode);
exports.ObjectNode = ObjectNode;
//# sourceMappingURL=object-node.model.js.map