import { IObjectTree } from '@jacquesparis/objects-model';
import { ContentEntityService } from './../services/content-entity.service';
import { AclCtx } from './acl-ctx.model';
import { EntityName } from './entity-name';
import { ObjectNode } from './object-node.model';
import { ObjectType } from './object-type.model';
export declare class ObjectTree implements IObjectTree {
    treeNode: ObjectNode;
    children: ObjectTree[];
    parentTree: ObjectTree;
    uri: string;
    id: string;
    parentTreeId: string;
    parentTreeUri: string;
    entityName: EntityName;
    aclCtx: AclCtx;
    constructor(treeNode: ObjectNode);
    get childrenByObjectTypeId(): {
        [objectTypeId: string]: ObjectTree[];
    };
    init(allNodes: ObjectNode[], contentEntityService: ContentEntityService, objectTypes: {
        [id: string]: ObjectType;
    }): Promise<ObjectTree>;
}
