"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AccessRightNodeService = void 0;
const tslib_1 = require("tslib");
const authorization_1 = require("@loopback/authorization");
const core_1 = require("@loopback/core");
const entity_name_1 = require("../../models/entity-name");
const object_node_service_1 = require("../object-node.service");
const access_rights_abtract_service_1 = require("./access-rights-abtract.service");
const access_rights_const_1 = require("./access-rights.const");
const access_rights_service_1 = require("./access-rights.service");
let AccessRightNodeService = class AccessRightNodeService extends access_rights_abtract_service_1.AccessRightAbstractService {
    constructor(accessRightsService, objectNodeService) {
        super(accessRightsService, entity_name_1.EntityName.objectNode);
        this.accessRightsService = accessRightsService;
        this.objectNodeService = objectNodeService;
    }
    async authorizeRead(ctx, context) {
        return authorization_1.AuthorizationDecision.DENY;
    }
    async authorizeCreate(ctx, context) {
        let node = null;
        node = await ctx.nodeContext.parent.getOrSetValue(async () => {
            var _a;
            return this.objectNodeService.searchById((_a = context.invocationContext.args[0]) === null || _a === void 0 ? void 0 : _a.parentNodeId);
        });
        if (node) {
            return (await this.accessRightsService.hasNodeAccessRight(access_rights_const_1.AccessRightsScope.create, node, ctx))
                ? authorization_1.AuthorizationDecision.ALLOW
                : authorization_1.AuthorizationDecision.DENY;
        }
        return authorization_1.AuthorizationDecision.DENY;
    }
    async authorizeUpdate(ctx, context) {
        let node = null;
        node = await ctx.nodeContext.node.getOrSetValue(async () => {
            return this.objectNodeService.searchById(context.invocationContext.args[0]);
        });
        if (node) {
            return (await this.accessRightsService.hasNodeAccessRight(access_rights_const_1.AccessRightsScope.update, node, ctx))
                ? authorization_1.AuthorizationDecision.ALLOW
                : authorization_1.AuthorizationDecision.DENY;
        }
        return authorization_1.AuthorizationDecision.DENY;
    }
    async authorizeDelete(ctx, context) {
        let node = null;
        node = await ctx.nodeContext.node.getOrSetValue(async () => {
            return this.objectNodeService.searchById(context.invocationContext.args[0]);
        });
        if (node) {
            return (await this.accessRightsService.hasNodeAccessRight(access_rights_const_1.AccessRightsScope.delete, node, ctx))
                ? authorization_1.AuthorizationDecision.ALLOW
                : authorization_1.AuthorizationDecision.DENY;
        }
        return authorization_1.AuthorizationDecision.DENY;
    }
    async cleanReturnedEntity(entity, ctx) {
        const objectNode = entity;
        objectNode.aclCtx = {
            rights: await this.accessRightsService.getNodeAccessRights(objectNode, ctx),
        };
    }
};
AccessRightNodeService = tslib_1.__decorate([
    core_1.injectable({ scope: core_1.BindingScope.SINGLETON }),
    tslib_1.__param(0, core_1.service(access_rights_service_1.AccessRightsService)),
    tslib_1.__param(1, core_1.service(object_node_service_1.ObjectNodeService)),
    tslib_1.__metadata("design:paramtypes", [access_rights_service_1.AccessRightsService,
        object_node_service_1.ObjectNodeService])
], AccessRightNodeService);
exports.AccessRightNodeService = AccessRightNodeService;
//# sourceMappingURL=access-rights-node.service.js.map