"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ACCESS_RIGHTS_ACCESS_MANAGERS_TYPE = exports.ACCESS_RIGHTS_OWNERS_TYPE = exports.ACCESS_RIGHTS_GROUP_TYPE = exports.ACCESS_RIGHT_OWNERS_NODE = exports.ACCESS_RIGHTS_DEFINITION_TYPE = exports.ACCESS_RIGHT_SUBTYPE = exports.AccessRightPermissions = exports.AccessRightSet = exports.AccessRightCRUD = exports.AccessRightPermission = exports.AccessRightMgt = exports.AccessRightsScope = exports.AccessRightsEntity = void 0;
const entity_name_1 = require("../../models/entity-name");
const application_service_1 = require("../application.service");
exports.AccessRightsEntity = entity_name_1.EntityName;
var AccessRightsScope;
(function (AccessRightsScope) {
    AccessRightsScope["create"] = "create";
    AccessRightsScope["read"] = "read";
    AccessRightsScope["update"] = "update";
    AccessRightsScope["delete"] = "delete";
})(AccessRightsScope = exports.AccessRightsScope || (exports.AccessRightsScope = {}));
var AccessRightMgt;
(function (AccessRightMgt) {
    AccessRightMgt["access"] = "access";
    AccessRightMgt["owner"] = "owner";
})(AccessRightMgt = exports.AccessRightMgt || (exports.AccessRightMgt = {}));
var AccessRightPermission;
(function (AccessRightPermission) {
    AccessRightPermission["create"] = "create";
    AccessRightPermission["read"] = "read";
    AccessRightPermission["update"] = "update";
    AccessRightPermission["delete"] = "delete";
    AccessRightPermission["access"] = "access";
    AccessRightPermission["owner"] = "owner";
})(AccessRightPermission = exports.AccessRightPermission || (exports.AccessRightPermission = {}));
class AccessRightCRUD {
    constructor(create = false, read = false, update = false, _delete = false) {
        this.create = create;
        this.read = read;
        this.update = update;
        this.delete = _delete;
    }
}
exports.AccessRightCRUD = AccessRightCRUD;
class AccessRightSet {
    constructor() {
        this.create = false;
        this.read = false;
        this.update = false;
        this.delete = false;
        this.access = false;
        this.owner = false;
    }
    toAccessRightCRUD() {
        return new AccessRightCRUD(this.create, this.read, this.update, this.delete);
    }
}
exports.AccessRightSet = AccessRightSet;
class AccessRightPermissions {
    constructor() {
        this.treeRootNode = new AccessRightSet();
        this.treeChildrenNodes = new AccessRightSet();
    }
}
exports.AccessRightPermissions = AccessRightPermissions;
exports.ACCESS_RIGHT_SUBTYPE = {
    name: 'Access Rights',
    acl: false,
    owner: false,
    namespace: false,
    tree: true,
    min: 1,
    max: 1,
    exclusions: [],
    mandatories: [],
};
exports.ACCESS_RIGHTS_DEFINITION_TYPE = {
    name: application_service_1.ApplicationService.OBJECT_TYPE_NAMES.ACCESS_RIGHT_DEFINITION,
    contentType: application_service_1.ApplicationService.CONTENT_TYPE.JSON,
    definition: {
        properties: {
            resetCreate: {
                type: 'boolean',
                title: 'Reset creation rights',
                default: false,
            },
            resetRead: {
                type: 'boolean',
                title: 'Reset read rights',
                default: false,
            },
            resetUpdate: {
                type: 'boolean',
                title: 'Reset update rights',
                default: false,
            },
            resetDelete: {
                type: 'boolean',
                title: 'Reset deletion rights',
                default: false,
            },
        },
    },
};
exports.ACCESS_RIGHT_OWNERS_NODE = {
    name: 'Owners',
};
exports.ACCESS_RIGHTS_GROUP_TYPE = {
    name: application_service_1.ApplicationService.OBJECT_TYPE_NAMES.ACCESS_RIGHT_GROUP,
    contentType: application_service_1.ApplicationService.CONTENT_TYPE.JSON,
    definition: {
        properties: {
            grantCreate: {
                type: 'boolean',
                title: 'Grant creation rights',
                default: false,
            },
            grantRead: {
                type: 'boolean',
                title: 'Grant read rights',
                default: false,
            },
            grantUpdate: {
                type: 'boolean',
                title: 'Grant update rights',
                default: false,
            },
            grantDelete: {
                type: 'boolean',
                title: 'Grant deletion rights',
                default: false,
            },
        },
    },
};
exports.ACCESS_RIGHTS_OWNERS_TYPE = {
    name: application_service_1.ApplicationService.OBJECT_TYPE_NAMES.ACCESS_RIGHT_OWNERS,
    contentType: application_service_1.ApplicationService.CONTENT_TYPE.JSON,
    definition: {
        properties: {
            resetOwner: {
                type: 'boolean',
                title: 'Reset owners rights',
                default: false,
            },
        },
    },
};
exports.ACCESS_RIGHTS_ACCESS_MANAGERS_TYPE = {
    name: application_service_1.ApplicationService.OBJECT_TYPE_NAMES.ACCESS_RIGHT_ACCESS_MANAGERS,
    contentType: application_service_1.ApplicationService.CONTENT_TYPE.JSON,
    definition: {
        properties: {
            resetAccess: {
                type: 'boolean',
                title: 'Reset access management rights',
                default: false,
            },
        },
    },
};
//# sourceMappingURL=access-rights.const.js.map