import { ObjectNode } from '../../models';
import { ObjectTree } from '../../models/object-tree.model';
import { ApplicationService, CurrentContext } from '../application.service';
import { ContentEntityService } from '../content-entity.service';
import { ObjectNodeService } from '../object-node.service';
import { ObjectTypeService } from '../object-type.service';
export declare class ObjectTreeService {
    private objectNodeService;
    private objectTypeService;
    private contentEntityService;
    private appCtx;
    get ready(): Promise<void>;
    private init;
    constructor(objectNodeService: ObjectNodeService, objectTypeService: ObjectTypeService, contentEntityService: ContentEntityService, appCtx: ApplicationService);
    getOwnerTreeNodes(ownerType: string, ownerName: string, ctx: CurrentContext): Promise<ObjectNode[]>;
    buildTreeFromNodes(treeNode: ObjectNode, availableNodes: ObjectNode[], ctx: CurrentContext): Promise<ObjectTree>;
    getOwnerTree(ownerType: string, ownerName: string, ctx: CurrentContext): Promise<ObjectTree>;
    getTreeNodes(ownerType: string, ownerName: string, namespaceType: string, namespaceName: string, treeType: string, treeName: string, ctx: CurrentContext): Promise<ObjectNode[]>;
    getTree(ownerType: string, ownerName: string, namespaceType: string, namespaceName: string, treeType: string, treeName: string, ctx: CurrentContext): Promise<ObjectTree>;
    getNamespaceNodes(ownerType: string, ownerName: string, namespaceType: string, namespaceName: string, ctx: CurrentContext): Promise<ObjectNode[]>;
    gettNamespaceTree(ownerType: string, ownerName: string, namespaceType: string, namespaceName: string, ctx: CurrentContext): Promise<ObjectTree>;
    loadChildrenNodes(treeId: string, ctx: CurrentContext): Promise<ObjectNode[]>;
    loadTree(treeId: string, ctx: CurrentContext): Promise<ObjectTree>;
    isInTree(tree: ObjectTree, node: ObjectNode): boolean;
    getChildOfType(tree: ObjectTree, objectTypeId: string): ObjectTree;
}
